# mReschke git helpers

alias gits='git --no-pager status'
alias gitc='git --no-pager config -l'
alias gitb='git --no-pager branch -a'
alias gitd='GIT_PAGER=cat git diff'
alias gitdl='GIT_PAGER=less git diff'
alias gitl='GIT_PAGER=less git log'

function ga() {
    git add .
    git commit -a -m "$1"
}

function gap() {
    git add .
    git commit -a -m "$1"
    git push
}

function gt() {
    git tag -a $1 -m "Tagged for $1 release"
    git push origin $1
}

function git-merge-into() {
    into=$1
    branch=$(git branch | sed -n '/\* /s///p')
    if [[ $into == "" ]]; then
        echo "Usage: git-merge-into master"
        return
    elif [[ $branch == "" ]]; then
        echo "Please push your current '$branch' branch first"
        return
    fi
    pushed=$(git status | grep -c 'nothing to commit')
    if [[ $pushed -eq 1 ]]; then
        echo -n "You are about to merge $branch into $into.  Are you sure? "; read response
        if [[ $response == "y" ]]; then
            git checkout $into && git merge $branch && git push && git checkout $branch
        fi
    fi
}

